/* NewPing Library gemaakt door Tim Eckel teckel@leethost.com.
  Copyright 2012 Licentie: GNU GPL v3
  http://www.gnu.org/licenses/gpl-3.0.html
*/
#include <NewPing.h>    //  Roept NewPing-bibliotheek aan
#include <Servo.h>      //  Roept Servo-bibliotheek aan
#define trigPin 12	//  Activatie-pen verbonden met Arduino 12
#define echoPin 13	//  Echo-pen verbonden met Arduino 13
#define MAX_DISTANCE 500

NewPing sonar(trigPin, echoPin, MAX_DISTANCE); // Bibliotheek instelling

int greenLed = 3, redLed = 2; // Stel groen ledje in op pen 3, rood op pen 2

int pos = 20;
Servo myservo;

void setup() {
  Serial.begin (115200);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(greenLed, OUTPUT);
  pinMode(redLed, OUTPUT);
  myservo.attach(9);          // Servo aangesloten op pen 9

}
void loop() {
  int duration, distance, pos = 0, i;

  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);  // Activatie-pen stuurt een ping
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH);  // Echo ontvangt de ping
  distance = (duration / 2) / 29.1;
  Serial.print(distance);
  Serial.println(" cm");

  if (distance <= 15) 			//  Als sensor objecten detecteert binnen 15 cm
  {
    digitalWrite(greenLed, LOW);  // Schakel groen ledje uit
    digitalWrite(redLed, HIGH);   // Schakel rood ledje in
    myservo.write(180);		   // Beweeg servo-arm 180 graden
    delay(450);
    digitalWrite(redLed, LOW); // Zet het rode ledje aan
    myservo.write(90);
    delay(450);
    digitalWrite(redLed, HIGH);
    myservo.write(0);
    delay(450);
    digitalWrite(redLed, LOW);
    myservo.write(90);
  }
  else { 				  //  Anders
    digitalWrite(redLed, LOW);    // Schakel het rode ledje uit
    digitalWrite(greenLed, HIGH); // Schakel het groene ledje in
    myservo.write(90);
  }

  delay(450);
}

