
#include <NewPing.h> // Roep NewPing-bibliotheek aan
#include <Servo.h> // Roep Servo-bibliotheek aan
#define trigPin 12 // Pen verbonden met ultrasone sensor Trig
#define echoPin 13 // Pen verbonden met de ultrasone sensor Echo
#define MAX_DISTANCE 500
NewPing sonar(trigPin, echoPin, MAX_DISTANCE);
int blaster = 3; // Pen verbonden met blaster
int angle = 0; // Stel servo-positie in graden in
Servo servo;
void setup() {
  Serial.begin (115200);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(blaster, OUTPUT);
  servo.attach(9); // Pen verbonden met servo
}
void loop() {
  int duration, distance, pos = 0, i;
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH); // Trig pen verstuurt een ping
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  duration = pulseIn(echoPin, HIGH); // Echo pen ontvangt de ping
  distance = (duration / 2) / 29.1;
  Serial.print(distance);
  Serial.println(" cm");
  if (distance <= 15) { // Als afstand minder dan 15 cm is
    digitalWrite(blaster, HIGH); // zal de blaster vuren
    servo.write(90);
  }
  else {
    digitalWrite(blaster, LOW); // Anders wordt de blaster niet geactiveerd
    for (angle = 0; angle < 180; angle++) { // Servo gaat heen en weer
      servo.write(angle);
      delay(15);
    }
    for (angle = 180; angle > 0; angle--) {
      servo.write(angle);
    }
    delay(450);
  }
}
