/*Gemaakt op 18 September 2012
  door Scott Fitzgerald Met dank aan Federico Vanzati voor de verbeteringen
  http://arduino.cc/starterKit
  Deze voorbeeld-code is onderdeel van het publiek domein.
*/
#include <Servo.h>
Servo servo9; // Pen verbonden met servo
const int piezo = A0; // Pen verbonden met piëzo
const int switchPin = 2; // Pen verbonden met servo
const int yellowLed = 3; // Pen verbonden met geel ledje
const int greenLed = 4; // Pen verbonden met groen ledje
const int redLed = 5; // Pen verbonden met rood ledje
int knockVal; // Waarde voor sterkte van kloppen
int switchVal;
const int quietKnock = 10; // Stel min. waarde in die wordt geaccepteerd
const int loudKnock = 100; // Stel max. waarde in die wordt geaccepteerd
boolean locked = false; // Een waar of niet-waar variabele
int numberOfKnocks = 0; // Waarde voor aantal kloppen
void setup() {
  servo9.attach(9);
  pinMode(yellowLed, OUTPUT); // Stel led pennen in als input
  pinMode(greenLed, OUTPUT);
  pinMode(redLed, OUTPUT);
  pinMode(switchPin, INPUT); // Stel servo pen in als input
  Serial.begin(9600);
  digitalWrite(greenLed, HIGH); // Groen ledje brandt wanneer
  // volgorde correct is
  servo9.write(0);
  Serial.println("The box is unlocked!");
}
void loop() {
  if (locked == false) {
    switchVal = digitalRead(switchPin);
    if (switchVal == HIGH) {
      locked = true;
      digitalWrite(greenLed, LOW);
      digitalWrite(redLed, HIGH);
      servo9.write(90);
      Serial.println("The box is locked!");
      delay(1000);
    }
  }
  if (locked == true) {
    knockVal = analogRead(piezo); // Waarde van kloppen uitgelezen door analoge pen
    if (numberOfKnocks < 3 && knockVal > 0) {
      if (checkForKnock(knockVal) == true) { // Controleer op juiste
        // aantal kloppen
        numberOfKnocks++;
      }
      Serial.print(3 - numberOfKnocks);
      Serial.println(" more knocks to go");
    }
    if (numberOfKnocks >= 3) { // Als 3 geldige kloppen worden gedetecteerd
      // beweegt de servo
      locked = false;
      servo9.write(0);
      delay(20);
      digitalWrite(greenLed, HIGH);
      digitalWrite(redLed, LOW);
      Serial.println("The box is unlocked!");
    }
  }
}
boolean checkForKnock(int value) { // Controleert waarde van kloppen
  if (value > quietKnock && value < loudKnock) { // Waarde moet
    // hiertussen liggen
    digitalWrite(yellowLed, HIGH);
    delay(50);
    digitalWrite(yellowLed, LOW);
    Serial.print("Valid knock of value ");
    Serial.println(value);
    return true;
  }
  else { // Als waarde niet waar is, stuur dan dit naar de seriële IDE
    Serial.print("Bad knock value ");
    Serial.println(value);
    return false;
  }
}
